;;-------------------------------------------------------------------------;;    This file is part of Catpang.
;;    Copyright (C) 2018-2019 Débora Galdeano González / Mª Inés Anton Castelló	
;;    Catpang is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;    (at your option) any later version.
;;
;;    Catpang is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.
;;
;;    You should have received a copy of the GNU General Public License
;;    along with Catpang.  If not, see <https://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------


.include "entity.h.s"
.include "main.h.s"
.include "nivel.h.s"


;; Datos iniciales Vida
;; ------------- 10x12
vida_w 	= #0x05
vida_h 	= ##0x0C

x_ini 	= #4
y_ini 	= #1

;;lose
x_txt	= #20
y_txt 	= #100

;;win
x_win	= #20
y_win 	= #100

;;chicago
x_ch	= #28
y_ch 	= #45

;;menu
x_m1	= #14
y_m1 	= #30

x_m2	= #10
y_m2 	= #140

;;bolas menu
x_azul = #45
y_azul = #20

x_roja = #14
y_roja = #100

x_verde = #55
y_verde = #110


.globl _vida_sp
.globl _win_sp
.globl _lose_sp
.globl _chicago_sp
.globl _m1_sp
.globl _m2_sp

;; DefineEntityDibujable _name, _activa, _x, _y, _w, _h, _sprite, _xAntigua, _yAntigua, _upd
DefineEntityDibujable vida1, #TRUE, #x_ini, #y_ini, #vida_w, #vida_h, #_vida_sp, #x_ini, #y_ini, 0
DefineEntityDibujable vida2, #TRUE, #10,    #y_ini, #vida_w, #vida_h, #_vida_sp, #10,    #y_ini, 0
DefineEntityDibujable vida3, #TRUE, #16,    #y_ini, #vida_w, #vida_h, #_vida_sp, #16,    #y_ini, 0

;; win: 78x12		lose: 86x12		chicago: 48x48
DefineEntityDibujable win,  #TRUE, #x_win, #y_win, #0x27, #0x0C, #_win_sp,  #x_win, #y_win, 0
DefineEntityDibujable lose, #TRUE, #x_txt, #y_txt, #0x2B, #0x0C, #_lose_sp, #x_txt, #y_txt, 0
DefineEntityDibujable chicago, #TRUE, #x_ch, #y_ch, #0x18, #0x30, #_chicago_sp, #x_ch, #y_ch, 0

;; m1: 80x80			m2: 96x36
DefineEntityDibujable m1,  #TRUE, #x_m1, #y_m1, #0x28, #0x50, #_m1_sp,  #x_m1, #y_m1, 0
DefineEntityDibujable m2,  #TRUE, #x_m2, #y_m2, #0x30, #0x24, #_m2_sp,  #x_m2, #y_m2, 0

;; Bolas
DefineEntityDibujable bola_azul,  #TRUE, #x_azul, #y_azul, #0x0D, #0x2A, #_b_grande_sp,  #x_azul, #y_azul, 0
DefineEntityDibujable bola_roja,  #TRUE, #x_roja, #y_roja, #0x08, #0x1A, #_b_mediana_sp,  #x_roja, #y_roja, 0
DefineEntityDibujable bola_verde,  #TRUE, #x_verde, #y_verde, #0x04, #0x1A, #_b_peque_sp,  #x_verde, #y_verde, 0



;;========================================
;;        Punteros IX e IY de las 3 vidas
;;========================================
vida1_getPtrIX:
	ld 		ix, #vida1
ret
vida2_getPtrIX:
	ld 		ix, #vida2
ret
vida3_getPtrIX:
	ld 		ix, #vida3
ret


;;======================================
;;	Reiniciar vidas
;;  Entrada IX -> Puntero a vida
;;======================================
reiniciar_vidas:
	call 	vida1_getPtrIX
	ld 		e_activada(ix), #TRUE

	call 	vida2_getPtrIX
	ld 		e_activada(ix), #TRUE

	call 	vida3_getPtrIX
	ld 		e_activada(ix), #TRUE
ret


;;======================================
;;	Desactivar vidas
;;  Entrada A -> Vida a borrar
;;======================================
vida_delete:
	
	;; 3
	cp #3
	jr z, borra3

		;; 2
		cp #2
		jr z, borra2

			;;1
			call 	vida1_getPtrIX
			ld 		e_activada(ix), #FALSE
			call 	hud_clear
			call 	personaje_getPtrIX
			ld 		e_activada(ix), #FALSE
			ret

	borra3:
		call 	vida3_getPtrIX
		ld 		e_activada(ix), #FALSE
	ret

	borra2:
		call 	vida2_getPtrIX
		ld 		e_activada(ix), #FALSE
	ret


;;======================================
;;	Dibujar las 3 vidas
;;======================================
hud_draw:
	call 	vida1_getPtrIX
	ld 		a, #TRUE 	;; Utiliza IX, por eso indica IX-TRUE
	call 	ent_draw

	call 	vida2_getPtrIX
	ld 		a, #TRUE
	call 	ent_draw

	call 	vida3_getPtrIX
	ld 		a, #TRUE
	call 	ent_draw
ret


;;======================================
;;	Limpiar las 3 vidas
;;======================================
hud_clear:
	call 	vida1_getPtrIX
	call 	ent_clear

	call 	vida2_getPtrIX
	call 	ent_clear

	call 	vida3_getPtrIX
	call 	ent_clear
ret


win_draw:
	ld 		ix, #win
	ld 		a, #TRUE
	call 	ent_draw
ret
win_clear:
	ld 		ix, #win
	call 	ent_clear
ret

lose_draw:
	ld 		ix, #lose
	ld 		a, #TRUE
	call 	ent_draw
ret
lose_clear:
	ld 		ix, #lose
	call 	ent_clear
ret

chicago_draw:
	ld 		ix, #chicago
	ld 		a, #TRUE
	call 	ent_draw
ret
chicago_clear:
	ld 		ix, #chicago
	call 	ent_clear
ret 

menu_draw:
	ld 		ix, #m1
	ld 		a, #TRUE
	call 	ent_draw

	ld 		ix, #m2
	ld 		a, #TRUE
	call 	ent_draw

	ld 		ix, #bola_azul
	ld 		a, #TRUE
	call 	ent_draw

	ld 		ix, #bola_roja
	ld 		a, #TRUE
	call 	ent_draw

	ld 		ix, #bola_verde
	ld 		a, #TRUE
	call 	ent_draw
ret
menu_clear:
	ld 		ix, #m1
	call 	ent_clear
	ld 		ix, #m2
	call 	ent_clear
	ld 		ix, #bola_azul
	call 	ent_clear
	ld 		ix, #bola_roja
	call 	ent_clear
	ld 		ix, #bola_verde
	call 	ent_clear
ret


easter_egg:
	call 	win_draw
	call 	chicago_draw
	call 	cpct_waitVSYNC_asm
	call 	ren_switchBuffers
	call 	chicago_clear
	call 	win_clear
ret

trans_win:
	call 	win_draw
	call 	cpct_waitVSYNC_asm
	call 	ren_switchBuffers
	call 	win_clear
ret

trans_lose:
	call 	lose_draw
	call 	cpct_waitVSYNC_asm
	call 	ren_switchBuffers
	call 	lose_clear
ret