;;-------------------------------------------------------------------------;;    This file is part of Catpang.
;;    Copyright (C) 2018-2019 Débora Galdeano González / Mª Inés Anton Castelló	
;;    Catpang is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;    (at your option) any later version.
;;
;;    Catpang is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.
;;
;;    You should have received a copy of the GNU General Public License
;;    along with Catpang.  If not, see <https://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------


;;======================================
;;		  Paleta y video mode
;;======================================
.globl cpct_disableFirmware_asm
.globl cpct_setVideoMode_asm
.globl cpct_setPalette_asm
.globl _paleta_pal					;; _ se pone delante porque viene de C


;;======================================
;;		  Doble Buffer
;;======================================
.globl cpct_setVideoMemoryPage_asm
.globl cpct_memset_f64_asm


;;======================================
;;	  Dibujar Sprites, Cajas y Texto
;;======================================
.globl cpct_getScreenPtr_asm
.globl cpct_drawSolidBox_asm
.globl cpct_drawSprite_asm
.globl cpct_drawSpriteMasked_asm
;.globl cpct_drawStringM0_asm
;.globl cpct_putChar_asm
.globl cpct_waitVSYNC_asm


;;======================================
;;		  		Teclado
;;======================================
.globl cpct_scanKeyboard_asm
.globl cpct_isKeyPressed_asm
.globl cpct_isAnyKeyPressed_asm

;;======================================
;;		  Creación de niveles
;;======================================
;.globl cpct_nextRandom_mxor_u16_asm
.globl crear_niveles


;;======================================
;;		  Tilemap y tileset
;;======================================
.globl cpct_zx7b_decrunch_s_asm
.globl cpct_etm_setDrawTilemap4x8_ag_asm
.globl cpct_etm_drawTilemap4x8_ag_asm
.globl decompress_buffer
.globl decompress_buffer_end
.globl _level1_pack_end
.globl _level2_pack_end
.globl _level3_pack_end
.globl _level4_pack_end
.globl _level5_pack_end
.globl _level6_pack_end
.globl _level1_W
.globl _level2_W
.globl _level3_W
.globl _level4_W
.globl _level5_W
.globl _level6_W

.globl descomprimir_pack
.globl set_Valores_tilemap
.globl dibujar_tilemap

;;======================================
;;		  		Musica
;;======================================
.globl cpct_setInterruptHandler_asm
.globl cpct_setPALColour_asm
.globl cpct_akp_musicInit_asm
.globl cpct_akp_musicPlay_asm
.globl _musica

;;======================================
;;		  Constantes globales
;;======================================
limiteIzq 	== 	#4			;; Max. = 0
limiteDer 	== 	#72			;; Max. = 79
limiteDerGATO 	== 	#75								;; Provisional
limiteArb 	== 	#24
limiteAbj 	== 	#192
finLapso 	== 	#1000
finInvuln	== 	#60
finParp  	== 	#5
iniContGATO ==	#1
iniVida 	==  #3
xCentro   	==	#40
yPrincipio 	== 	#160		;; Para el personaje
TRUE 		== 	#0
FALSE 		== 	#1
nivel1		== 	#1
nivel2		== 	#2
nivel3		== 	#3
nivel4		== 	#4
nivel5		== 	#5
nivel6		== 	#6
iniBallX1	==  #54
iniBallY1	==  #45
iniBallX2	==  #36
iniBallY2	==  #85
iniBallX3	==  #25
iniBallY3	==  #66
iniBallX4	==  #16
iniBallY4	==  #96
iniBallX5	==  #14
iniBallY5	==  #150

