;;-------------------------------------------------------------------------;;    This file is part of Catpang.
;;    Copyright (C) 2018-2019 Débora Galdeano González / Mª Inés Anton Castelló	
;;    Catpang is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;    (at your option) any later version.
;;
;;    Catpang is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.
;;
;;    You should have received a copy of the GNU General Public License
;;    along with Catpang.  If not, see <https://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------


;; include CPCtelera constant definitions, macros and variables
.include "cpctelera.h.s"
.include "main.h.s"
.include "entity.h.s"
.include "nivel.h.s"

.area CODE

DefineNivel nivel, #1, #0, #0

nivel_getPtrIX:
	ld 		ix, #nivel
ret
nivel_getPtrIY:
	ld 		iy, #nivel
ret
nivel_getPtrHL:
	ld 		hl, #nivel
ret

;;======================================
;;        Creación de un nivel
;;======================================
crear_niveles:
	ld 		c, #1
	
	loop_level:
	cp 		c
	jr 		z, elegir_nivel
	inc 	c
	jr 		loop_level

	elegir_nivel:
	dec 	a
	jr 		z, crear_nivel_uno
	dec 	a
	jr 		z, crear_nivel_dos
	dec 	a
	jr 		z, crear_nivel_tres
	dec 	a
	jr 		z, crear_nivel_cuatro
	dec 	a
	jr 		z, crear_nivel_cinco
	dec 	a
	jr 		z, crear_nivel_seis

	crear_nivel_uno:
	call 	nivel_getPtrIX
	ld 		e_nivelNumBalls(ix), #nivel1
	ld 		e_nivelTotalNumBalls(ix), #nivel1
	ld 		a, #nivel1
	;_b = nivel1
	jr 		loop_crear_level
	crear_nivel_dos:
	call 	nivel_getPtrIX
	ld 		e_nivelNumBalls(ix), #nivel2
	ld 		e_nivelTotalNumBalls(ix), #nivel2
	ld 		a, #nivel2
	;_b = nivel2
	jr 		loop_crear_level
	crear_nivel_tres:
	call 	nivel_getPtrIX
	ld 		e_nivelNumBalls(ix), #nivel3
	ld 		e_nivelTotalNumBalls(ix), #nivel3
	ld 		a, #nivel3
	;_b = nivel3
	jr 		loop_crear_level
	crear_nivel_cuatro:
	call 	nivel_getPtrIX
	ld 		e_nivelNumBalls(ix), #nivel4
	ld 		e_nivelTotalNumBalls(ix), #nivel4
	ld 		a, #nivel4
	;_b = nivel4
	jr 		loop_crear_level
	crear_nivel_cinco:
	call 	nivel_getPtrIX
	ld 		e_nivelNumBalls(ix), #nivel5
	ld 		e_nivelTotalNumBalls(ix), #nivel5
	ld 		a, #nivel5
	;_b = nivel5
	jr 		loop_crear_level
	crear_nivel_seis:
	call 	nivel_getPtrIX
	ld 		e_nivelNumBalls(ix), #nivel6
	ld 		e_nivelTotalNumBalls(ix), #nivel6
	ld 		a, #nivel6
	;_b = nivel6
	jr 		loop_crear_level

	loop_crear_level:

	call 	bola_grande_vector_getPtrIX
	ld 		hl, (m_next_ball)	
	ld 		bc, #k_balls_size
	cp 		#6
	jr 		z, seis_bolas
	cp 		#5
	jr 		z, cinco_bolas
	cp 		#4
	jr 		z, cuatro_bolas
	cp 		#3
	jr 		z, tres_bolas
	cp 		#2
	jr 		z, dos_bolas
	


	continua_nivel:

	push 	af
	push 	hl
	push 	bc
	call	bola_new		;; vector + 1 y hl contiene la nueva bola
	ex 		de, hl
	ld 		hl, #bola_grande
	call 	bola_copy
	pop 	bc
	pop 	hl
	pop 	af

	dec 	a
	cp 		#0
	jr		z, 	fin
	ret

	seis_bolas:
	call 		continua_nivel
	
	ld 		de_x(ix), #iniBallX5 
	ld 		de_y(ix), #iniBallY5
	ld 		e_vx(ix), #-1
	call 	avanzar_en_array

	cinco_bolas:
	call 		continua_nivel
	
	ld 		de_x(ix), #iniBallX4 
	ld 		de_y(ix), #iniBallY4
	ld 		e_vy(ix), #11
	call 	avanzar_en_array

	cuatro_bolas:
	call 		continua_nivel
	
	ld 		de_x(ix), #iniBallX3 
	ld 		de_y(ix), #iniBallY3
	ld 		e_vy(ix), #8
	ld 		e_vx(ix), #-1
	call 	avanzar_en_array

	tres_bolas:
	call 		continua_nivel
	
	ld 		de_x(ix), #iniBallX2 
	ld 		de_y(ix), #iniBallY2
	ld 		e_vy(ix), #10
	call 	avanzar_en_array

	dos_bolas:
	call 		continua_nivel
	
	ld 		de_x(ix), #iniBallX1 
	ld 		de_y(ix), #iniBallY1
	ld 		e_vy(ix), #5
	ld 		e_vx(ix), #-1
	call 	avanzar_en_array
	
	call 		continua_nivel

	avanzar_en_array:
	add		hl, bc 						
	ld 		(m_next_ball), hl 
	ld 		ix, (m_next_ball)
	ret

	fin:

ret


;; A -> Nivel
cargar_mapa:
	ld 		c, #1
	
	loop_mapa:
	cp 		c
	jr 		z, elegir_mapa
	inc 	c
	jr 		loop_mapa

	elegir_mapa:
	dec 	a
	jr 		z, crear_mapa_1
	dec 	a
	jr 		z, crear_mapa_2
	dec 	a
	jr 		z, crear_mapa_3
	dec 	a
	jr 		z, crear_mapa_4
	dec 	a
	jr 		z, crear_mapa_5
	dec 	a
	jr 		z, crear_mapa_6

	crear_mapa_1:
	ld 		hl, #_level1_pack_end
	call 	descomprimir_pack

	ld 		de, #_level1_W
	call 	set_Valores_tilemap
	jr 		dibujar

	crear_mapa_2:
	ld 		hl, #_level2_pack_end
	call 	descomprimir_pack

	ld 		de, #_level2_W
	call 	set_Valores_tilemap
	jr 		dibujar

	crear_mapa_3:
	ld 		hl, #_level3_pack_end
	call 	descomprimir_pack

	ld 		de, #_level3_W
	call 	set_Valores_tilemap
	jr 		dibujar

	crear_mapa_4:
	ld 		hl, #_level4_pack_end
	call 	descomprimir_pack

	ld 		de, #_level4_W
	call 	set_Valores_tilemap
	jr 		dibujar

	crear_mapa_5:
	ld 		hl, #_level5_pack_end
	call 	descomprimir_pack

	ld 		de, #_level5_W
	call 	set_Valores_tilemap
	jr 		dibujar

	crear_mapa_6:
	ld 		hl, #_level6_pack_end
	call 	descomprimir_pack

	ld 		de, #_level6_W
	call 	set_Valores_tilemap
	jr 		dibujar

	dibujar:
	call 	dibujar_tilemap
ret