;;-------------------------------------------------------------------------;;    This file is part of Catpang.
;;    Copyright (C) 2018-2019 Débora Galdeano González / Mª Inés Anton Castelló	
;;    Catpang is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;    (at your option) any later version.
;;
;;    Catpang is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.
;;
;;    You should have received a copy of the GNU General Public License
;;    along with Catpang.  If not, see <https://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------


.include "cpctelera.h.s"
.include "entity.h.s"
.include "main.h.s"
.include "nivel.h.s"


;; Datos iniciales Personaje
.globl _personaje_sp
vidaActual = #3

;; ------------- 12x32
p_w = #0x06
p_h = ##0x20


;;DefineHero 	_name, _activa,	_x, 	_y, 	   _w, 	 _h, 		_sprite, _xAntigua, _yAntigua, 		_upd, 		_vx, _vidas		_invul  _cont_inv _par 	 _cont_par
DefineHero personaje, #TRUE, #xCentro, #yPrincipio, #p_w, #p_h, #_personaje_sp, #xCentro, #yPrincipio, ent_moveHero, #0, #vidaActual, #FALSE, #1, #FALSE, #1 


;;======================================
;;        Punteros a personaje
;;======================================
personaje_getPtrIX:
	ld 		ix, #personaje
ret

;;======================================
;;	Reiniciar valores del personaje
;;  Entrada IX -> Puntero a entidad
;;======================================
reiniciar_personaje:
	;; Borramos la antigua posicion
	call ent_restart

	;; Asignamos la nueva posicion y reiniciamos contador vidas
	ld 		de_x(ix), #xCentro
	ld 		de_y(ix), #yPrincipio
	ld 		e_vida(ix), #iniVida
	ld 		e_activada(ix), #TRUE
	call 	reset_invulnerable
ret


;;======================================
;;	Leer teclado
;;	Registros destruidos: HL, A, L
;;  Entrada IX -> Puntero a entidad
;;======================================
ent_moveHero:
	;; Guardar la posicion antigua de X
	ld 		a, de_x(ix)
	ld 		xAntigua(ix), a


	;;call 	ent_colision_bola_jugador

	;;cp 		#TRUE	
	;;jr 		nz, no_colisiones
	;;dec		e_col(ix)

	;;no_colisiones:
	call 	cpct_scanKeyboard_asm		;; Escanear todas las teclas
	ld 		hl, #Key_D 					;; HL = Key_D Keycode
	call 	cpct_isKeyPressed_asm		;; Comprueba si Key_D esta pulsada
	jr		z, d_no_pulsada				;; si Z=1, salta a d_no_pulsada

		;; D pulsada, Z=0
		ld 		a, de_x(ix)				;; Metemos en A la pos.
		add		de_w(ix)				;; Sumamos el ancho a la pos.
		cp 		#limiteDerGATO			;; 75
		jr		z, continua				;; si Z=1, salta a continua

		;; Dentro de la pantalla, Z=0
		ld 		e_vx(ix), #1
		jr		continua

	d_no_pulsada:

	ld 		hl, #Key_A 					;; HL = Key_A Keycode
	call 	cpct_isKeyPressed_asm		;; Comprueba si Key_A esta pulsada
	jr		z, continua				;; si Z=1, salta a a_no_pulsada

		;; A pulsada, Z=0
		ld 		a, de_x(ix)				;; Metemos en A la pos.
		cp 		#limiteIzq				;; 4
		jr		z, continua 			;; si Z=1, salta a continua

		;; Dentro de la pantalla, Z=0
		ld 		e_vx(ix), #-1
		jr 		continua
	;Debug
	;a_no_pulsada:
	;	ld 		hl, #Key_V 					;; HL = Key_V Keycode
	;	call 	cpct_isKeyPressed_asm		;; Comprueba si Key_V esta pulsada
	;	jr		z, v_no_pulsada				;; si Z=1, salta a v_no_pulsada


	;	ld 		a, e_vida(ix)				;; vidaActual = 3
	;	call 	vida_delete

	;	call 	personaje_getPtrIX
	;	sub 	#1
	;	ld 		e_vida(ix), a 				;; vidaActual = 2
	;	ret

	continua:
		call 	ent_move
		ld 		e_vx(ix), #0

	teclas_no_pulsadas:
ret


;;======================================
;;	Mover una entidad
;;	Registros destruidos: A
;;  Entrada IX -> Puntero a entidad
;;======================================
ent_move:
	ld 		a, de_x(ix)		;; Mete en A la pos. X
	add 	e_vx(ix)		;; Le suma la velocidad
	ld 		de_x(ix), a 	;; Mete en la pos. X la nueva pos.
ret


personaje_clear:
	call 	personaje_getPtrIX
	call 	ent_clear
ret


;;======================================
;;	Reducir vida
;;	Registros destruidos: A
;;  Entrada IX -> Puntero a personaje
;;======================================

jugador_vida_reduce:
	ld 		a, e_vida(ix)				;; vidaActual = 3
	call 	vida_delete

	call 	personaje_getPtrIX
	sub 	#1
	ld 		e_vida(ix), a 

ret

aumenta_contador_invuln:
	ld 		a, e_cont_invuln(ix)
	inc 	a
	ld 		e_cont_invuln(ix), a 		;; Aumenta el contador de invulnerabilidad
ret

aumenta_contador_parpadeo:
	ld 		a, e_cont_parp(ix)
	inc 	a
	ld 		e_cont_parp(ix), a
ret

reset_invulnerable:
	ld 		e_invulnerable(ix), #FALSE
	ld 		e_parpadeo(ix), 	#FALSE
	ld		e_cont_invuln(ix), 	#iniContGATO
	ld		e_cont_parp(ix), 	#iniContGATO
ret